﻿--------------------------------------------------------------------------
-- Credit to Morgalm for the sexy code that I used. And credit to whisp for the Timeframe if(statment)
--------------------------------------------------------------------------
local mod = SoDWhisper:NewModule("LDB/Minimap Plugin", "AceEvent-3.0")
local icon = LibStub("LibDBIcon-1.0", true)
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local L = LibStub("AceLocale-3.0"):GetLocale("SoDWhisper")
local QTC = LibStub('LibQTip-1.0')
local version = GetAddOnMetadata("SoDWhisper", "Version") 

mod.modName = L["LDB/Minimap Plugin"]

local brokerFrame = {}
local lengthFrame = {}
local tempdbOther, tempdbGuild, tempdbRegFriend, tempdbBN = {}, {}, {}, {}		-- function mod:DisplayTooltip
local LSUtempls = {}															-- function mod:LastSenderUpdate
local Timeframes = {L["Session"], L["Hour"], L["Day"], L["Week"], L["All"]}
local UIPlus = "|TInterface\\Buttons\\UI-PlusButton-Up:12:12:1:0|t"
local noAppAwayIcon = "|TInterface\\AddOns\\SoDWhisper\\MediaFiles\\noAppAwayIcon:0|t"
local lastsender = nil
local lastsenderpath = nil
local iconmissed = "Interface\\AddOns\\SoDWhisper\\MediaFiles\\iconmissed"
local icondefault = "Interface\\AddOns\\SoDWhisper\\MediaFiles\\icon"
local toolTUP = nil
local dbg, dbr

local defaults = {
	profile = {
		minimap = {
			hide = false,
		},
		tooltipTimeFrame = 1,			-- Which messages should be shown on the fubar tooltop
		tooltipSort = false,			-- Sort method for messages on the fubar tooltip (true = time)
		tooltipGuildTimeFrame = false,
		tooltipFriendsTimeFrame = false,
		noAppAway = true,
		frameWidth = 500,				-- Width of the frame
		maxheight = 300,				-- Max height of frame
		sortReverse = false,			-- Sort Direction (up or down)
		iconmissedtoggle = true,
		showFaGCount = true,
		messageHistoryBox = false,
		messagesort = true,
		skinframe = true,
		tooltipspace = 6,
	}
}

local options = {
	brokericon = {
		type = "group",
		order = 10,
		name = L["Icon"],
		disabled = function() return not mod:IsEnabled() end,
		args = {
			toggleminimap = {
				type = "toggle",
				order = 5,
				name = L["Hide Minimap Icon"],
				get = function() return mod.db.profile.minimap.hide end,
				set = function(_, v) 
					mod.db.profile.minimap.hide = v
					mod:ToggleMinimapIcon(v)
				end,
			},
			b2f = {
				type = "execute",
				order = 6,
				name = L["Broker2FuBar Options"],
				desc = L["Open the Broker2FuBar options panel."],
				hidden = function() return not IsAddOnLoaded('Broker2FuBar') end,
				func = function() LibStub("AceAddon-3.0"):GetAddon("Broker2FuBar", true):OpenGUI() end,
			},
			iconmissedtoggle = {
				type = "toggle",
				order = 10,
				name = L["Change Icon"],
				desc = L["Change icon while there is an unchecked messages."],
				get = function() return mod.db.profile.iconmissedtoggle end,
				set = function(_, v) mod.db.profile.iconmissedtoggle = v end,
			},
			showFaGCount = {
				type = "toggle",
				order = 15,
				name = L["Show Online Count"],
				desc = L["Show online count in LDB text (ex. 2Friends | 4Guild online)."],
				get = function() return mod.db.profile.showFaGCount end,
				set = function(_, v) 
					mod.db.profile.showFaGCount = v 
					mod:LastSenderUpdate() 
				end,
			},
		},
	},
------------------------------------------------------------------------------------------------------------------------------------------------------------
	brokerappearance = {
		type = "group",
		order = 15,
		name = L["Appearance"],
		disabled = function() return not mod:IsEnabled() end,
		args = {
			height = {
				type = "range",
				order = 5,
				name = L["Max Tooltip Height"],
				desc = L["Max height of tooltip before scrolling enables."],
				get = function() return mod.db.profile.maxheight end,
				set = 	function(_, v) mod.db.profile.maxheight = v end,
				min = 125, 
				max = 1500, 
				step = 25,
			},
			sortReverse = {
				type = 'toggle',
				order = 10,
				name = L["Tooltip Sort"],
				desc = L["Reverse sort direction for the main tooltip."],
				get = function() return mod.db.profile.sortReverse end,
				set = function(_, v) mod.db.profile.sortReverse = v end,
			},
			tooltipspace = {
				type = "range",
				order = 15,
				name = L["Tooltip Spacing"],
				desc = L["Space between tooltips."],
				get = function() return mod.db.profile.tooltipspace end,
				set = function(_, v) mod.db.profile.tooltipspace = v end,
				min = -15, 
				max = 15, 
				step = 1,
			},
			skinframe = {
				type = "toggle",
				order = 20,
				name = L["Format Tooltip"],
				desc = L["Set background and border of tooltip."],
				get = function() return mod.db.profile.skinframe end,
				set = function(_, v) mod.db.profile.skinframe = v end,
			},
		},
	},
------------------------------------------------------------------------------------------------------------------------------------------------------------
	brokermessage = {
		type = "group",
		order = 20,
		name = L["Messages"],
		desc = L["Message history for the LDB/Minimap tooltip."],
		disabled = function() return not mod:IsEnabled() end,
		args = {
			messageHistoryBox = {
				type = 'toggle',
				order = 5,
				name = L["Hide Message Panel"],
				desc = L["Hide message history panel and hover over missed message checking for LDB/Minimap tooltip."],
				get = function() return mod.db.profile.messageHistoryBox end,
				set = function(_, v) mod.db.profile.messageHistoryBox = v end,
			},
			messagewidth = {
				type = "range",
				order = 10,
				name = L["Panel Width"],
				desc = L["Panel Width of message history for LDB/Minimap tooltip."],
				get = function() return mod.db.profile.frameWidth end,
				set = function(_, v) 
					mod.db.profile.frameWidth = v 
					brokerFrame:SetWidth(v)
				end,
				min = 300, 
				max = 700, 
				step = 25,
				disabled = function() return mod.db.profile.messageHistoryBox end,
			},
			messagesort = {
				type = 'toggle',
				order = 15,
				name = L["Message Sort"],
				desc = L["Show entries from old to new on the message panel for the LDB/Minimap Plugin."],
				get = function() return mod.db.profile.messagesort end,
				set = function(_, v) mod.db.profile.messagesort = v end,
				disabled = function() return mod.db.profile.messageHistoryBox end,
			},
		},
	},
}
------------------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------- Initialisation Functions --------------------------------------------------------------------
function mod:OnInitialize()
	self.db = SoDWhisper.db:RegisterNamespace("Broker Plugin", defaults)
end
------------------------------------------------------------------------------------------------------------------------------------------------------------
function mod:OnEnable()
	mod:RegisterMessage("SoDWhisper_MESSAGE", "LastSenderUpdate")
	mod:RegisterMessage("SoDWhisper_SKIN", "OnSkinUpdate")
	dbg, dbr = SoDWhisper.db.global, SoDWhisper.db.factionrealm
	
	brokerFrame = SoDWhisper:CreateMyFrame("BROKER", self.db.profile.frameWidth)
		
	SoDWhisper.timeframe = mod.db.profile.tooltipTimeFrame
	
	lengthFrame = _G.CreateFrame("Frame", "SoDWhisper_LENGTH", UIParent)
	lengthFrame:SetScale(GameTooltip:GetScale())
	lengthFrame:SetWidth(600)  
	lengthFrame:SetHeight(400)
	lengthFrame.text = lengthFrame:CreateFontString("SoDWhisper_MEASURELENGTH","ARTWORK","GameTooltipText")
	
	mod:CreateLDBObject()
	if not icon:IsRegistered("SoDWhisper") then 
		icon:Register("SoDWhisper", mod.obj, mod.db.profile.minimap) 
	end
	
	self:OnSkinUpdate()
end
------------------------------------------------------------------------------------------------------------------------------------------------------------
function mod:OnDisable()
end
------------------------------------------------------------------------------------------------------------------------------------------------------------
function mod:OnSkinUpdate()
	SoDWhisper:SkinMyFrame(brokerFrame)
end
------------------------------------------------------------------------------------------------------------------------------------------------------------
function mod:ToggleMinimapIcon(HIDE)
	if HIDE then 
		icon:Hide("SoDWhisper")
	else 
		icon:Show("SoDWhisper") 
	end
end
------------------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------ LDB/Minimap Display --------------------------------------------------------------------------
function mod:LastSenderUpdate()
	lastsender, lastsenderpath = SoDWhisper.lastSender, SoDWhisper.lastSenderPath
	local GuildFriends, tempSubtract = "", 0
 
	if dbr.chatHistory then
		for i,v in pairs(dbr.chatHistory) do
			if v.time and v.tells > 0 then
				tinsert(LSUtempls, {time = v.time[#v.time], plr = i, tells = v.tells, isDBR = true})
			end
		end
	end
	if dbg.chatHistory then
		for i,v in pairs(dbg.chatHistory) do
			if v.time and v.tells > 0 then
				tinsert(LSUtempls, {time = v.time[#v.time], plr = i, tells = v.tells, isDBR = false})
			end 
			if mod.db.profile.showFaGCount and mod.db.profile.noAppAway and v.online and v.client == "App" and v.status and string.find(v.status, "<AFK>") then
				tempSubtract = tempSubtract + 1
			end
		end
	end
	
	if mod.db.profile.showFaGCount then
		GuildFriends = "|cff00ff00"..((SoDWhisper.OnlineRegFriends or 0) + (SoDWhisper.OnlineBNFriends or 0) - tempSubtract).."|r|||cff00ff00"..(SoDWhisper.OnlineGuildNum or 0).."|r "
	end
	
	table.sort(LSUtempls, function(a,b) return a.time>b.time end)
	
	if LSUtempls[1] then
		lastsender = LSUtempls[1].plr
		lastsenderpath = LSUtempls[1].isDBR and dbr or dbg
		
		local lastsendercombi
		if lastsenderpath.chatHistory[lastsender].online then
			lastsendercombi = lastsenderpath.chatHistory[lastsender].displayName..string.format("(%s)", LSUtempls[1].tells)
			lastsendercombi = SoDWhisper:FormatPlayerName(lastsendercombi, lastsender, lastsenderpath)
		else
			lastsendercombi = "|c00585858"..lastsenderpath.chatHistory[lastsender].displayName.."|r"..string.format("(%s)", LSUtempls[1].tells)
		end

		mod.obj.text = GuildFriends..lastsendercombi
		mod.obj.icon = mod.db.profile.iconmissedtoggle and iconmissed or icondefault
		_G.wipe(LSUtempls)
	elseif lastsender and lastsenderpath.chatHistory[lastsender] then
		local lastsendercombi
		if lastsenderpath.chatHistory[lastsender].online then
			lastsendercombi = SoDWhisper:FormatPlayerName(lastsenderpath.chatHistory[lastsender].displayName, lastsender, lastsenderpath)
		else
			lastsendercombi = "|c00585858"..lastsenderpath.chatHistory[lastsender].displayName.."|r"
		end
		
		mod.obj.text = GuildFriends..lastsendercombi.."    "
		mod.obj.icon = icondefault
	else
		mod.obj.text = GuildFriends.."SoDWhisper "
		mod.obj.icon = icondefault
		lastsender, lastsenderpath = nil, nil
	end
	if mod.tooltipSoDWhisperTitle and mod.tooltipSoDWhisperTitle:IsShown() then
		mod:DisplayTooltip()
	end
end
------------------------------------------------------------------------------------------------------------------------------------------------------------
function mod:CreateLDBObject()
	if mod.obj then return end
	mod.obj = ldb:NewDataObject("SoDWhisper", {
		type = "data source",
		text = "SoDWhisper",
		icon = icondefault,
		OnClick = function(frame, button)
			if button == "RightButton" then
				if IsControlKeyDown() then
					_G.ToggleGuildFrame(1)
				else
					SoDWhisper:OpenConfig()
				end
			else
				if IsControlKeyDown() and IsShiftKeyDown() and IsAltKeyDown() then
					_G.wipe(SoDWhisper.db.factionrealm.chatHistory)
					_G.wipe(SoDWhisper.db.global.chatHistory)
					SoDWhisper:UpdateOnLoad()
				elseif IsControlKeyDown() then
					_G.ToggleFriendsFrame(1)
				elseif lastsender then
					if( lastsenderpath == dbg ) then
						local presID, plr = SoDWhisper:CompareBattleTag(lastsender)
						if presID then
							plr = plr..":"..presID
							SetItemRef( "BNplayer:"..plr, ("|HBNplayer:%1$s|h[%1$s]|h"):format(plr), "LeftButton")
						end
					else
						SetItemRef("player:"..lastsender, "|Hplayer:"..lastsender.."|h["..lastsender.."]|h", "LeftButton")
					end
				end
			end
		end,
		OnEnter = function(frame)
		
			local tooltipFriends = QTC:Acquire("SoDWhisper_FriendsTooltip", 6)
			tooltipFriends:Clear()
			tooltipFriends:ClearAllPoints()
			tooltipFriends:SetScript("OnLeave", mod.HideTooltip)
			tooltipFriends:SetScript("OnUpdate", function(f) if not MouseIsOver(frame) then mod:HideTooltip() end end)
			
			--------------------------------------------------------------------------------------
			local tooltipGuild = QTC:Acquire("SoDWhisper_GuildTooltip", 4)
			tooltipGuild:Clear()
			tooltipGuild:ClearAllPoints()			
			tooltipGuild:SetScript("OnLeave", mod.HideTooltip)
			tooltipGuild:SetScript("OnUpdate", function(f) if not MouseIsOver(frame) then mod:HideTooltip() end end)
						
			--------------------------------------------------------------------------------------
			local tooltipOther = QTC:Acquire("SoDWhisper_OtherTooltip", 4)
			tooltipOther:Clear()
			tooltipOther:ClearAllPoints()			
			tooltipOther:SetScript("OnLeave", mod.HideTooltip)
			tooltipOther:SetScript("OnUpdate", function(f) if not MouseIsOver(frame) then mod:HideTooltip() end end)
			
			--------------------------------------------------------------------------------------
			local tooltipSoDWhisperTitle = QTC:Acquire("SoDWhisper_SoDWhisperTitleTooltip", 4)
			tooltipSoDWhisperTitle:Clear()
			tooltipSoDWhisperTitle:ClearAllPoints()	
			tooltipSoDWhisperTitle:SetScript("OnLeave", mod.HideTooltip)
			tooltipSoDWhisperTitle:SetScript("OnUpdate", function(f) if not MouseIsOver(frame) then mod:HideTooltip() end end)
			
			--------------------------------------------------------------------------------------
			local rightT = select(1, frame:GetCenter()) > UIParent:GetWidth() * .9
			local leftT = select(1, frame:GetCenter()) < UIParent:GetWidth() * .1 
			local xpointT = (rightT and "RIGHT") or (leftT and "LEFT") or "" 
			local istopT = select(2, frame:GetCenter()) > UIParent:GetHeight() / 2
			
			if istopT then
				toolTUP = nil
				tooltipSoDWhisperTitle:SetPoint("TOP"..xpointT, frame, "BOTTOM"..xpointT, 8, 0)
				tooltipSoDWhisperTitle:SetFrameLevel(_G.GameTooltip:GetFrameLevel() + 14)
				
				tooltipOther:SetPoint("TOP"..xpointT, tooltipSoDWhisperTitle, "BOTTOM"..xpointT, 0, mod.db.profile.tooltipspace)
				tooltipOther:SetFrameLevel(_G.GameTooltip:GetFrameLevel() + 16)
				
				tooltipGuild:SetPoint("TOP"..xpointT, tooltipOther, "BOTTOM"..xpointT, 0, mod.db.profile.tooltipspace)
				tooltipGuild:SetFrameLevel(_G.GameTooltip:GetFrameLevel() + 18)
				
				tooltipFriends:SetPoint("TOP", tooltipGuild, "BOTTOM", 0, mod.db.profile.tooltipspace)
				tooltipFriends:SetFrameLevel(_G.GameTooltip:GetFrameLevel() + 20)
			else
				toolTUP = true
				tooltipFriends:SetPoint("BOTTOM", frame, "TOP")
				tooltipFriends:SetFrameLevel(_G.GameTooltip:GetFrameLevel() + 20)
			
				tooltipGuild:SetPoint("BOTTOM", tooltipFriends, "TOP", 0, -mod.db.profile.tooltipspace)
				tooltipGuild:SetFrameLevel(_G.GameTooltip:GetFrameLevel() + 18)
			
				tooltipOther:SetPoint("BOTTOM", tooltipGuild, "TOP", 0, -mod.db.profile.tooltipspace)
				tooltipOther:SetFrameLevel(_G.GameTooltip:GetFrameLevel() + 16)
			
				tooltipSoDWhisperTitle:SetPoint("BOTTOM", tooltipOther, "TOP", 0, -mod.db.profile.tooltipspace)
				tooltipSoDWhisperTitle:SetFrameLevel(_G.GameTooltip:GetFrameLevel() + 14)
			end
			
			mod.tooltipSoDWhisperTitle = tooltipSoDWhisperTitle
			mod.tooltipOther = tooltipOther
			mod.tooltipGuild = tooltipGuild
			mod.tooltipFriends = tooltipFriends
			
			mod:DisplayTooltip()
		end,
		OnLeave = function()
			mod:HideTooltip()
		end,
	})
end
------------------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------- Tooltip Display --------------------------------------------------------------------------
function mod:HideTooltip(force)
	if self.tooltipFriends or self.tooltipGuild or self.tooltipOther or self.tooltipSoDWhisperTitle then
		if (MouseIsOver(self.tooltipFriends) or MouseIsOver(self.tooltipGuild) or MouseIsOver(self.tooltipOther) or MouseIsOver(self.tooltipSoDWhisperTitle)) and not force then return end
		self.tooltipFriends:SetScript("OnLeave", nil)
		self.tooltipFriends:SetScript("OnUpdate", nil)
		self.tooltipFriends:Hide()
		QTC:Release(self.tooltipFriends)
		self.tooltipFriends = nil
		
		self.tooltipGuild:SetScript("OnLeave", nil)
		self.tooltipGuild:SetScript("OnUpdate", nil)
		self.tooltipGuild:Hide()
		QTC:Release(self.tooltipGuild)
		self.tooltipGuild = nil
		
		self.tooltipOther:SetScript("OnLeave", nil)
		self.tooltipOther:SetScript("OnUpdate", nil)
		self.tooltipOther:Hide()
		QTC:Release(self.tooltipOther)
		self.tooltipOther = nil
		
		self.tooltipSoDWhisperTitle:SetScript("OnLeave", nil)
		self.tooltipSoDWhisperTitle:SetScript("OnUpdate", nil)
		self.tooltipSoDWhisperTitle:Hide()
		QTC:Release(self.tooltipSoDWhisperTitle)
		self.tooltipSoDWhisperTitle = nil
		
		brokerFrame:Hide()
	end
end
------------------------------------------------------------------------------------------------------------------------------------------------------------
function mod:HandleTTClick(name, button)
	if not name then return end
	local db = mod.db.profile
	local path = (dbr.chatHistory[name] and dbr) or dbg

	if name == "timeframe" then
		if button == "RightButton" then
			db.tooltipTimeFrame = db.tooltipTimeFrame - 1
			if db.tooltipTimeFrame < 1 then 
				db.tooltipTimeFrame = 5 
			end
		else
			db.tooltipTimeFrame = db.tooltipTimeFrame + 1
			if db.tooltipTimeFrame > 5 then 
				db.tooltipTimeFrame = 1 
			end
		end
		SoDWhisper.timeframe = db.tooltipTimeFrame
		SoDWhisper:UpdateOtherToons()
	elseif name == "sortby" then
		db.tooltipSort = not db.tooltipSort 
	elseif name == "other" then
		if IsShiftKeyDown() then
			for i,v in pairs(dbr.chatHistory) do
				if not v.typeBNtoon and not v.typeGuild and not v.typeRegFriend then
					if not v.changed then 
						dbr.chatHistory[i] = nil
					else 
						v.sender, v.message, v.time, v.incoming, v.tells = {}, {}, {}, {}, 0 
					end
				end
			end
			mod:LastSenderUpdate()
			return
		else
			return
		end
	elseif name == "guild" then
		if IsShiftKeyDown() then
			for i,v in pairs(dbr.chatHistory) do
				if v.typeGuild and not v.typeRegFriend then
					if not v.changed then 
						dbr.chatHistory[i] = nil
					else 
						v.sender, v.message, v.time, v.incoming, v.tells = {}, {}, {}, {}, 0 
					end
				end
			end
			SoDWhisper:UpdateGuild()
			return
		else
			db.tooltipGuildTimeFrame = not db.tooltipGuildTimeFrame
		end
	elseif name == "friends" then
		if IsShiftKeyDown() then
			for i,v in pairs(dbr.chatHistory) do
				if v.typeRegFriend then
					if not v.changed then 
						dbr.chatHistory[i] = nil
					else 
						v.sender, v.message, v.time, v.incoming, v.tells = {}, {}, {}, {}, 0 
					end
				end
			end
			for i,v in pairs(dbg.chatHistory) do
				if not v.changed then 
					dbg.chatHistory[i] = nil
				else 
					v.sender, v.message, v.time, v.incoming, v.tells = {}, {}, {}, {}, 0 
				end
			end
			SoDWhisper:UpdateBNFriends()
			SoDWhisper:UpdateRegFriends()
			return
		elseif button == "MiddleButton" then
			if db.tooltipFriendsTimeFrame then
				db.noAppAway = not db.noAppAway
				mod:LastSenderUpdate()
				return
			end
		else
			db.tooltipFriendsTimeFrame = not db.tooltipFriendsTimeFrame
		end
	elseif button == "RightButton" then
		if IsControlKeyDown() then 
			SoDWhisper:UpdateChangePlayerName(SoDWhisper.createDisplayName, name, path)
		elseif path.chatHistory[name].toon and dbr.chatHistory[path.chatHistory[name].toon] then 
			SetItemRef("player:"..path.chatHistory[name].toon, "|Hplayer:"..path.chatHistory[name].toon.."|h["..path.chatHistory[name].toon.."]|h", "LeftButton")
		end
	else
		if IsControlKeyDown() then
			SoDWhisper:ShowLogFrame(SoDWhisper.LogFrame, name, path)
		elseif IsShiftKeyDown() then
			path.chatHistory[name].sender, path.chatHistory[name].message, path.chatHistory[name].time, path.chatHistory[name].incoming, path.chatHistory[name].tells = {}, {}, {}, {}, 0 
			mod:LastSenderUpdate()
			return
		elseif IsAltKeyDown() then
			if path.chatHistory[name].pID then
				_G.FriendsFrame_BattlenetInvite(nil, path.chatHistory[name].pID)
			else
				_G.InviteUnit(name)
			end
		else
			if path == dbg then
				local presID, plr = SoDWhisper:CompareBattleTag(name)
				if presID then
					plr = plr..":"..presID
					SetItemRef( "BNplayer:"..plr, ("|HBNplayer:%1$s|h[%1$s]|h"):format(plr), "LeftButton")
				end
			else
				SetItemRef("player:"..name, "|Hplayer:"..name.."|h["..name.."]|h", "LeftButton")
			end
		end
	end
	mod:DisplayTooltip()
end
------------------------------------------------------------------------------------------------------------------------------------------------------------
function mod:DisplayTooltip()
	if not mod.tooltipSoDWhisperTitle then return end
	local db = mod.db.profile
	
	mod.tooltipSoDWhisperTitle:Clear()
	mod.tooltipOther:Clear()
	mod.tooltipGuild:Clear()
	mod.tooltipFriends:Clear()
	local tooltipOther = mod.tooltipOther
	local tooltipGuild = mod.tooltipGuild
	local tooltipFriends = mod.tooltipFriends
	local tooltipSoDWhisperTitle = mod.tooltipSoDWhisperTitle
	
	if mod.db.profile.skinframe then
		tooltipOther:SetBackdrop({bgFile = "Interface\\ChatFrame\\ChatFrameBackground", tile = true, tileSize = 16,	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", 
					edgeSize = 16,	insets = {left = 3, right = 3, top = 3, bottom = 3}})
		tooltipOther:SetBackdropColor(0, 0, 0, 1)
		tooltipOther:SetBackdropBorderColor(0.6, 0.6, 0.6, 1)
		
		tooltipGuild:SetBackdrop({bgFile = "Interface\\ChatFrame\\ChatFrameBackground", tile = true, tileSize = 16,	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", 
					edgeSize = 16,	insets = {left = 3, right = 3, top = 3, bottom = 3}})
		tooltipGuild:SetBackdropColor(0, 0, 0, 1)
		tooltipGuild:SetBackdropBorderColor(0.6, 0.6, 0.6, 1)
		
		tooltipFriends:SetBackdrop({bgFile = "Interface\\ChatFrame\\ChatFrameBackground", tile = true, tileSize = 16,	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", 
					edgeSize = 16,	insets = {left = 3, right = 3, top = 3, bottom = 3}})
		tooltipFriends:SetBackdropColor(0, 0, 0, 1)
		tooltipFriends:SetBackdropBorderColor(0.6, 0.6, 0.6, 1)
		
		tooltipSoDWhisperTitle:SetBackdrop({bgFile = "Interface\\ChatFrame\\ChatFrameBackground", tile = true, tileSize = 16,	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", 
					edgeSize = 16,	insets = {left = 3, right = 3, top = 3, bottom = 3}})
		tooltipSoDWhisperTitle:SetBackdropColor(0, 0, 0, 1)
		tooltipSoDWhisperTitle:SetBackdropBorderColor(0.6, 0.6, 0.6, 1)
	end
	
	local ttime = time()
	
	for i,v in pairs(dbr.chatHistory) do
		if v.message[1] and not v.typeBNtoon and not v.typeRegFriend and not v.typeGuild then
			local systime = v.time[#v.time]
		
			if ((db.tooltipTimeFrame == 1 and systime < SoDWhisper.sessionStart) or (db.tooltipTimeFrame == 2 and ttime - systime > 3600) or (db.tooltipTimeFrame == 3 and ttime - systime > 86400) or (db.tooltipTimeFrame == 4 and ttime - systime > 604800)) then
			else 
				tinsert(tempdbOther, {time = v.time[#v.time], plr = i, tells = v.tells, display = v.displayName}) 
			end
		end
		if v.typeGuild and (v.online or v.message[1]) then
			local systime = v.time[#v.time]
			if not systime then systime = 1000000 end
			
			if not db.tooltipGuildTimeFrame and v.message[1] then
				if ((db.tooltipTimeFrame == 1 and systime < SoDWhisper.sessionStart) or (db.tooltipTimeFrame == 2 and ttime - systime > 3600) or (db.tooltipTimeFrame == 3 and ttime - systime > 86400) or (db.tooltipTimeFrame == 4 and ttime - systime > 604800)) then
				else 
					tinsert(tempdbGuild, {time = v.time[#v.time], plr = i, tells = v.tells, display = v.displayName}) 
				end
			elseif db.tooltipGuildTimeFrame and v.online then 
				tinsert(tempdbGuild, {time = systime, plr = i, tells = v.tells, display = v.displayName}) 
			end
		end
		if v.typeRegFriend and (v.online or v.message[1]) then
			local systime = v.time[#v.time]
			if not systime then systime = 1000000 end
			
			if not db.tooltipFriendsTimeFrame and v.message[1] then
				if ((db.tooltipTimeFrame == 1 and systime < SoDWhisper.sessionStart) or (db.tooltipTimeFrame == 2 and ttime - systime > 3600) or (db.tooltipTimeFrame == 3 and ttime - systime > 86400) or (db.tooltipTimeFrame == 4 and ttime - systime > 604800)) then
				else 
					tinsert(tempdbRegFriend, {time = v.time[#v.time], plr = i, tells = v.tells, display = v.displayName}) 
				end
			elseif db.tooltipFriendsTimeFrame and v.online then 
				tinsert(tempdbRegFriend, {time = systime, plr = i, tells = v.tells, display = v.displayName}) 
			end
		end
	end
	
	for i,v in pairs(dbg.chatHistory) do
		if v.message[1] or v.online then
			local systime = v.time[#v.time]
			if not systime then systime = 1000000 end
			
			if not db.tooltipFriendsTimeFrame and v.message[1] then
				if ((db.tooltipTimeFrame == 1 and systime < SoDWhisper.sessionStart) or (db.tooltipTimeFrame == 2 and ttime - systime > 3600) or (db.tooltipTimeFrame == 3 and ttime - systime > 86400) or (db.tooltipTimeFrame == 4 and ttime - systime > 604800)) then
				else 
					tinsert(tempdbBN, {time = v.time[#v.time], plr = i, tells = v.tells, display = v.displayName})
				end
			elseif db.tooltipFriendsTimeFrame and v.online then 
				if not db.noAppAway then
					tinsert(tempdbBN, {time = systime, plr = i, tells = v.tells, display = v.displayName}) 
				elseif v.client == "App" and v.status and string.find(v.status, "<AFK>") then
				else
					tinsert(tempdbBN, {time = systime, plr = i, tells = v.tells, display = v.displayName}) 
				end
			end
		end
	end
	
	if db.sortReverse then
		if not db.tooltipSort then
			table.sort(tempdbOther, function(a,b) return a.display>b.display end)
			table.sort(tempdbGuild, function(a,b) return a.display>b.display end)
			table.sort(tempdbRegFriend, function(a,b) return a.display>b.display end)
			table.sort(tempdbBN, function(a,b) return a.display>b.display end)
		else
			table.sort(tempdbOther, function(a,b) return a.time<b.time end)
			table.sort(tempdbGuild, function(a,b) return a.time<b.time end)
			table.sort(tempdbRegFriend, function(a,b) return a.time<b.time end)
			table.sort(tempdbBN, function(a,b) return a.time<b.time end)
		end
	else
		if not db.tooltipSort then
			table.sort(tempdbOther, function(a,b) return a.display<b.display end)
			table.sort(tempdbGuild, function(a,b) return a.display<b.display end)
			table.sort(tempdbRegFriend, function(a,b) return a.display<b.display end)
			table.sort(tempdbBN, function(a,b) return a.display<b.display end)
		else
			table.sort(tempdbOther, function(a,b) return a.time>b.time end)
			table.sort(tempdbGuild, function(a,b) return a.time>b.time end)
			table.sort(tempdbRegFriend, function(a,b) return a.time>b.time end)
			table.sort(tempdbBN, function(a,b) return a.time>b.time end)
		end
	end
	
	lengthFrame.text:SetFontObject(_G.GameTooltipText)
	
	local BNsidesW, levelW, nameW, tellsW, zoneW = 0, 0, 0, 0, 0
	local tempT
	if tempdbOther[1] or tempdbGuild[1] or tempdbRegFriend[1] or tempdbBN[1] then
		lengthFrame.text:SetText("00")
		levelW = lengthFrame.text:GetStringWidth()
		for i,v in pairs(tempdbOther) do
			lengthFrame.text:SetText(SoDWhisper:GetDisplayNameForTooltip(v.plr, dbr, nil, nil, nil, 0))
			tempT = lengthFrame.text:GetStringWidth()
			if nameW < tempT then nameW = tempT end
			lengthFrame.text:SetText(v.tells)
			tempT = lengthFrame.text:GetStringWidth()
			if tellsW < tempT then tellsW = tempT end
			lengthFrame.text:SetText(dbr.chatHistory[v.plr].zone or "")
			tempT = lengthFrame.text:GetStringWidth()
			if zoneW < tempT then zoneW = tempT end
		end
		for i,v in pairs(tempdbGuild) do
			lengthFrame.text:SetText(SoDWhisper:GetDisplayNameForTooltip(v.plr, dbr, nil, nil, nil, 0))
			tempT = lengthFrame.text:GetStringWidth()
			if nameW < tempT then nameW = tempT end
			lengthFrame.text:SetText(v.tells)
			tempT = lengthFrame.text:GetStringWidth()
			if tellsW < tempT then tellsW = tempT end
			lengthFrame.text:SetText(dbr.chatHistory[v.plr].zone or "")
			tempT = lengthFrame.text:GetStringWidth()
			if zoneW < tempT then zoneW = tempT end
		end
		for i,v in pairs(tempdbRegFriend) do
			lengthFrame.text:SetText(SoDWhisper:GetDisplayNameForTooltip(v.plr, dbr, nil, nil, nil, 0))
			tempT = lengthFrame.text:GetStringWidth()
			if nameW < tempT then nameW = tempT end
			lengthFrame.text:SetText(v.tells)
			tempT = lengthFrame.text:GetStringWidth()
			if tellsW < tempT then tellsW = tempT end
			lengthFrame.text:SetText(dbr.chatHistory[v.plr].zone or "")
			tempT = lengthFrame.text:GetStringWidth()
			if zoneW < tempT then zoneW = tempT end
			lengthFrame.text:SetText(SoDWhisper:GetRealmForTooltip(v.plr, true, 0, dbr))
			tempT = lengthFrame.text:GetStringWidth()
			if BNsidesW < tempT then BNsidesW = tempT end
		end
		for i,v in pairs(tempdbBN) do
			lengthFrame.text:SetText(SoDWhisper:GetDisplayNameForTooltip(v.plr, dbg, true, true))
			tempT = lengthFrame.text:GetStringWidth()
			if BNsidesW < tempT then BNsidesW = tempT end
			lengthFrame.text:SetText(SoDWhisper:GetDisplayNameForTooltip(v.plr, dbg, true, nil, nil, 0))
			tempT = lengthFrame.text:GetStringWidth()
			if nameW < tempT then nameW = tempT end
			lengthFrame.text:SetText(v.tells)
			tempT = lengthFrame.text:GetStringWidth()
			if tellsW < tempT then tellsW = tempT end
			lengthFrame.text:SetText(dbg.chatHistory[v.plr].zone or "")
			tempT = lengthFrame.text:GetStringWidth()
			if zoneW < tempT then zoneW = tempT end
			lengthFrame.text:SetText(SoDWhisper:GetRealmForTooltip(v.plr, true, 0, dbg))
			tempT = lengthFrame.text:GetStringWidth()
			if BNsidesW < tempT then BNsidesW = tempT end
		end	
	end
	BNsidesW, levelW, tellsW, nameW, zoneW = BNsidesW + 5, levelW + 2, tellsW + 2, nameW + 5, zoneW + 5
	if BNsidesW < 50 then BNsidesW = 50 end
	local temp1stTitlemin = nameW + levelW + tellsW
	local time2ndTitlemin = zoneW
	if temp1stTitlemin < 95 then 
		temp1stTitlemin = 95
		nameW = 95 - levelW - tellsW
	end
	if time2ndTitlemin < 105 then 
		time2ndTitlemin = 105 
		zoneW = 105
	end
	local paddingConstant = 6
	local padding = 0
	---------------------------------------------------------------------------------------------
	local y = tooltipSoDWhisperTitle:AddLine()
	tooltipSoDWhisperTitle:SetCell(y, 1, "|c001eff00" .. "SoDWhisper " .. "|r" .. version, nil, "CENTER", 4)  
	tooltipSoDWhisperTitle:AddLine(" ")
	
	y = tooltipSoDWhisperTitle:AddHeader()
	tooltipSoDWhisperTitle:SetCell(y, 1, UIPlus..L["TimeframeTitle"], nil, "LEFT", 3, nil, nil, nil, temp1stTitlemin + paddingConstant, temp1stTitlemin + paddingConstant)
	tooltipSoDWhisperTitle:SetCell(y, 4, Timeframes[db.tooltipTimeFrame], nil, "RIGHT", 1, nil, nil, nil, time2ndTitlemin + paddingConstant, time2ndTitlemin + paddingConstant)
	tooltipSoDWhisperTitle:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, "timeframe") 
	
	y = tooltipSoDWhisperTitle:AddHeader()
	tooltipSoDWhisperTitle:SetCell(y, 1, UIPlus..L["Sort by"], nil, "LEFT", 3, nil, nil, nil, temp1stTitlemin + paddingConstant, temp1stTitlemin + paddingConstant)
	tooltipSoDWhisperTitle:SetCell(y, 4, (db.tooltipSort and L["Time"]) or L["Name"], nil, "RIGHT", 1, nil, nil, nil, time2ndTitlemin + paddingConstant, time2ndTitlemin + paddingConstant)
	tooltipSoDWhisperTitle:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, "sortby")
	---------------------------------------------------------------------------------------------
	if not tempdbOther[1] then padding = paddingConstant end
	y = tooltipOther:AddHeader()
	tooltipOther:SetCell(y, 1, UIPlus..L["Other"], nil, "LEFT", 3, nil, nil, nil, temp1stTitlemin + padding, temp1stTitlemin + padding)
	tooltipOther:SetCell(y, 4, L["Timeframe"], nil, "RIGHT", 1, nil, nil, nil, time2ndTitlemin + padding, time2ndTitlemin + padding)
	tooltipOther:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, "other") 
	
	if tempdbOther[1] then
		for i,v in pairs(tempdbOther) do
			y = tooltipOther:AddLine()
			tooltipOther:SetCell(y, 1, SoDWhisper:GetColoredLevel(dbr.chatHistory[v.plr].level, dbr.chatHistory[v.plr].online), nil, "CENTER", 1, nil, nil, nil, levelW, levelW)
			tooltipOther:SetCell(y, 2, SoDWhisper:GetDisplayNameForTooltip(v.plr, dbr, nil, nil, nil, 0), nil, "LEFT", 1, nil, nil, nil, nameW, nameW)
			tooltipOther:SetCell(y, 3, SoDWhisper:GetTells(v.plr, dbr), nil, "CENTER", 1, nil, nil, nil, tellsW, tellsW)
			tooltipOther:SetCell(y, 4, SoDWhisper:GetZoneColor(dbr.chatHistory[v.plr].zone, dbr.chatHistory[v.plr].online), nil, "CENTER", 1, nil, nil, nil, zoneW, zoneW)
			tooltipOther:SetLineScript(y, "OnEnter", mod.ShowBrokerFrame, v.plr) 
			tooltipOther:SetLineScript(y, "OnLeave", mod.HideBrokerFrame) 			
			tooltipOther:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, v.plr) 
		end
	end
	---------------------------------------------------------------------------------------------
	if not tempdbGuild[1] then padding = paddingConstant
	else padding = 0 end
	y = tooltipGuild:AddHeader()
	tooltipGuild:SetCell(y, 1, UIPlus..L["Guild"], nil, "LEFT", 3, nil, nil, nil, temp1stTitlemin + padding, temp1stTitlemin + padding)
	tooltipGuild:SetCell(y, 4, (db.tooltipGuildTimeFrame and L["Online"]) or L["Timeframe"], nil, "RIGHT", 1, nil, nil, nil, time2ndTitlemin + padding, time2ndTitlemin + padding)
	tooltipGuild:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, "guild") 
		
	if tempdbGuild[1] then
		for i,v in pairs(tempdbGuild) do
			y = tooltipGuild:AddLine()
			tooltipGuild:SetCell(y, 1, SoDWhisper:GetColoredLevel(dbr.chatHistory[v.plr].level, dbr.chatHistory[v.plr].online), nil, "CENTER", 1, nil, nil, nil, levelW, levelW)
			tooltipGuild:SetCell(y, 2, SoDWhisper:GetDisplayNameForTooltip(v.plr, dbr, nil, nil, nil, 0), nil, "LEFT", 1, nil, nil, nil, nameW, nameW)
			tooltipGuild:SetCell(y, 3, SoDWhisper:GetTells(v.plr, dbr), nil, "CENTER", 1, nil, nil, nil, tellsW, tellsW)
			tooltipGuild:SetCell(y, 4, SoDWhisper:GetZoneColor(dbr.chatHistory[v.plr].zone, dbr.chatHistory[v.plr].online), nil, "CENTER", 1, nil, nil, nil, zoneW, zoneW)
			tooltipGuild:SetLineScript(y, "OnEnter", mod.ShowBrokerFrame, v.plr) 
			tooltipGuild:SetLineScript(y, "OnLeave", mod.HideBrokerFrame) 			
			tooltipGuild:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, v.plr) 
		end
	end
	---------------------------------------------------------------------------------------------
	if not tempdbBN[1] then padding = paddingConstant * 2
	else padding = 0 end
	tempT = db.tooltipFriendsTimeFrame and L["Online"] or L["Timeframe"]
	if db.tooltipFriendsTimeFrame and db.noAppAway then
		tempT = noAppAwayIcon.." "..tempT
	end
	y = tooltipFriends:AddHeader()
	tooltipFriends:SetCell(y, 1, UIPlus..L["Friends"], nil, "LEFT", 4, nil, nil, nil, temp1stTitlemin + BNsidesW + padding, temp1stTitlemin + BNsidesW + padding)
	tooltipFriends:SetCell(y, 5, tempT, nil, "RIGHT", 2, nil, nil, nil, time2ndTitlemin + BNsidesW + padding, time2ndTitlemin + BNsidesW + padding)
	tooltipFriends:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, "friends") 
	
	if tempdbBN[1] then
		for i,v in pairs(tempdbBN) do
			y = tooltipFriends:AddLine()
			tooltipFriends:SetCell(y, 1, SoDWhisper:GetDisplayNameForTooltip(v.plr, dbg, true, true), nil, "RIGHT", 1, nil, nil, nil, BNsidesW, BNsidesW)
			tooltipFriends:SetCell(y, 2, SoDWhisper:GetColoredLevel(dbg.chatHistory[v.plr].level, dbg.chatHistory[v.plr].online, true), nil, "CENTER", 1, nil, nil, nil, levelW, levelW)
			tooltipFriends:SetCell(y, 3, SoDWhisper:GetDisplayNameForTooltip(v.plr, dbg, true, nil, nil, 0), nil, "LEFT", 1, nil, nil, nil, nameW, nameW)
			tooltipFriends:SetCell(y, 4, SoDWhisper:GetTells(v.plr, dbg), nil, "CENTER", 1, nil, nil, nil, tellsW, tellsW)
			tooltipFriends:SetCell(y, 5, SoDWhisper:GetZoneColor(dbg.chatHistory[v.plr].zone, dbg.chatHistory[v.plr].online), nil, "CENTER", 1, nil, nil, nil, zoneW, zoneW)
			tooltipFriends:SetCell(y, 6, SoDWhisper:GetRealmForTooltip(v.plr, true, 0, dbg), nil, "CENTER", 1, nil, nil, nil, BNsidesW, BNsidesW)				
			tooltipFriends:SetLineScript(y, "OnEnter", mod.ShowBrokerFrame, v.plr) 
			tooltipFriends:SetLineScript(y, "OnLeave", mod.HideBrokerFrame) 			
			tooltipFriends:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, v.plr)
		end
	end
	if tempdbRegFriend[1] then
		for i,v in pairs(tempdbRegFriend) do
			y = tooltipFriends:AddLine()
			tooltipFriends:SetCell(y, 1, (dbr.chatHistory[v.plr].online and "-") or "|c00585858-|r", nil, "RIGHT", 1, nil, nil, nil, BNsidesW, BNsidesW)
			tooltipFriends:SetCell(y, 2, SoDWhisper:GetColoredLevel(dbr.chatHistory[v.plr].level, dbr.chatHistory[v.plr].online), nil, "CENTER", 1, nil, nil, nil, levelW, levelW)
			tooltipFriends:SetCell(y, 3, SoDWhisper:GetDisplayNameForTooltip(v.plr, dbr, nil, nil, nil, 0), nil, "LEFT", 1, nil, nil, nil, nameW, nameW)
			tooltipFriends:SetCell(y, 4, SoDWhisper:GetTells(v.plr, dbr), nil, "CENTER", 1, nil, nil, nil, tellsW, tellsW)
			tooltipFriends:SetCell(y, 5, SoDWhisper:GetZoneColor(dbr.chatHistory[v.plr].zone, dbr.chatHistory[v.plr].online), nil,"CENTER", 1, nil, nil, nil, zoneW, zoneW)
			tooltipFriends:SetCell(y, 6, SoDWhisper:GetRealmForTooltip(v.plr, true, 0, dbr), nil, "CENTER", 1, nil, nil, nil, BNsidesW, BNsidesW)
			tooltipFriends:SetLineScript(y, "OnEnter", mod.ShowBrokerFrame, v.plr) 
			tooltipFriends:SetLineScript(y, "OnLeave", mod.HideBrokerFrame) 			
			tooltipFriends:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, v.plr) 
		end
	end

	if db.maxheight ~= 0 then 
		if toolTUP then
			tooltipFriends:UpdateScrolling(db.maxheight)
			tooltipGuild:UpdateScrolling(db.maxheight)
			tooltipOther:UpdateScrolling(db.maxheight)
			tooltipSoDWhisperTitle:UpdateScrolling(db.maxheight) 
		else
			tooltipSoDWhisperTitle:UpdateScrolling(db.maxheight)
			tooltipOther:UpdateScrolling(db.maxheight)
			tooltipGuild:UpdateScrolling(db.maxheight)
			tooltipFriends:UpdateScrolling(db.maxheight)
		end
	end 

    local widthT
	tempT = tooltipOther:GetWidth()
	widthT = tempT
	tempT = tooltipGuild:GetWidth()
	if tempT > widthT then widthT = tempT end
	tempT = tooltipSoDWhisperTitle:GetWidth()
	if tempT > widthT then widthT = tempT end
	
	tooltipOther:SetWidth(widthT)
	tooltipGuild:SetWidth(widthT)
	tooltipSoDWhisperTitle:SetWidth(widthT)
	
	tooltipFriends:Show()
	tooltipGuild:Show()
	tooltipOther:Show()
	tooltipSoDWhisperTitle:Show()
	
	tooltipGuild:SetClampedToScreen(true)
	tooltipOther:SetClampedToScreen(true)
	tooltipSoDWhisperTitle:SetClampedToScreen(true)
	tooltipFriends:SetClampedToScreen(true)
	
	_G.wipe(tempdbOther)
	_G.wipe(tempdbGuild)
	_G.wipe(tempdbBN)
	_G.wipe(tempdbRegFriend)
end
------------------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------- Tools -------------------------------------------------------------------------------
function mod:ShowBrokerFrame(plr)
	if not plr or mod.db.profile.messageHistoryBox then return end
	local path, ignoreT
	
	if dbr.chatHistory[plr] then
		if dbr.chatHistory[plr].BT and BNFeaturesEnabledAndConnected() and dbr.chatHistory[plr].tells == 0 then
			ignoreT = true
			path = dbg
			plr = dbr.chatHistory[plr].BT
		else 
			path = dbr 
		end
	elseif dbg.chatHistory[plr] then
		path = dbg
	else return end
	
	if not path.chatHistory[plr].message[1] then return end
	
	brokerFrame:ClearAllPoints()
	if toolTUP then
		brokerFrame:SetPoint("BOTTOM", mod.tooltipSoDWhisperTitle, "TOP")
	else
		brokerFrame:SetPoint("TOP", mod.tooltipFriends, "BOTTOM")
	end
	
	SoDWhisper:UpdateMyFrame(brokerFrame, plr, path, mod.db.profile.messagesort, ignoreT)
	
	brokerFrame:Show()
	brokerFrame:SetClampedToScreen(true)
end
------------------------------------------------------------------------------------------------------------------------------------------------------------
function mod:HideBrokerFrame()
	brokerFrame:Hide()
end
------------------------------------------------------------------------------------------------------------------------------------------------------------
function mod:GetOptions()
	return options 
end
------------------------------------------------------------------------------------------------------------------------------------------------------------
function mod:Info()
	return L["Quickly view information from the minimap or type of LDB display."]
end